package mac10.connection;

public interface MessageConstants {
	/** states the action success */

	public static int PERCEPTION_INCOMPLETE = 0;
	public static int PERCEPTION_COMPLETE = 1;
	public static int PERCEPTION_CLEANUP = 2;
	public static int PERCEPTION_NO_ACTION = 3;
	public static int PERCEPTION_NO_CURRENT_ACTION = 4;
	public static int PERCEPTION_MOVE_NORTHEAST_FAILED = 5;
	public static int PERCEPTION_MOVE_SOUTHEAST_FAILED = 6;
	public static int PERCEPTION_MOVE_NORTH_FAILED = 7;
	public static int PERCEPTION_MOVE_SOUTH_FAILED = 8;
	public static int PERCEPTION_MOVE_EAST_FAILED = 9;
	public static int PERCEPTION_MOVE_WEST_FAILED = 10;
	public static int PERCEPTION_MOVE_NORTHWEST_FAILED = 11;
	public static int PERCEPTION_MOVE_SOUTHWEST_FAILED = 12;

	/** modification to action invocation */

	public static int INVOKE_NO_FAILURE = 0;
	public static int INVOKE_NEW_PATH = 1;
	public static int INVOKE_LAST_RETRY = 2;
	public static int INVOKE_CLEANUP = 4;

	/**
	 * possible agent actions
	 */

	public static final String ACTION_NORTH = "north";
	public static final String ACTION_SOUTH = "south";
	public static final String ACTION_WEST = "west";
	public static final String ACTION_EAST = "east";
	public static final String ACTION_NORTHEAST = "northeast";
	public static final String ACTION_SOUTHEAST = "southeast";
	public static final String ACTION_NORTHWEST = "northwest";
	public static final String ACTION_SOUTHWEST = "southwest";

	public static final String ACTION_SKIP = "skip";

	public static final String[] ACTION_ARRAY = new String[] { ACTION_NORTH,
			ACTION_NORTHEAST, ACTION_EAST, ACTION_SOUTHEAST, ACTION_SOUTH,
			ACTION_SOUTHWEST, ACTION_WEST, ACTION_NORTHWEST };

	/**
	 * possible message types
	 */

	public static final String MESSAGE_ACTION_REQUEST = "request-action";
	public static final String MESSAGE_ACTION_RESPONSE = "action";
	public static final String MESSAGE_AUTH_RESPONSE = "auth-response";
	public static final String MESSAGE_AUTH_REQUEST = "auth-request";
	public static final String MESSAGE_PONG = "pong";
	public static final String MESSAGE_SIM_START = "sim-start";
	public static final String MESSAGE_SIM_END = "sim-end";
	public static final String MESSAGE_BYE = "bye";
}
