package mac10.messages;

import java.util.ArrayList;

import mac10.models.Cell;

import de.dailab.jiactng.agentcore.knowledge.IFact;
import de.dailab.jiactng.agentcore.ontology.IAgentDescription;

public class PerceptionMessage implements IFact {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1117268269905852812L;

	private ArrayList<Cell> cells = null;
	private int step;
	private IAgentDescription senderAgentDecription;
	private int posx;
	private int posy;
	private long deadline;
	private int cowsInCorral;

	public PerceptionMessage(IAgentDescription senderAgentDecription,
			ArrayList<Cell> cells, int step, int posx, int posy, int cowsInCorral, long deadline) {
		this.senderAgentDecription = senderAgentDecription;
		this.cells = cells;
		this.step = step;
		this.posx = posx;
		this.posy = posy;
		this.cowsInCorral = cowsInCorral;
		this.deadline = deadline;
	}

	public String toString() {
		return ("perception");
	}

	public IAgentDescription getSenderDescription() {
		return senderAgentDecription;
	}

	public ArrayList<Cell> getCells() {
		return cells;
	}

	public int getStep() {
		return this.step;
	}

	public int getPosx() {
		return posx;
	}

	public int getPosy() {
		return posy;
	}

	public long getDeadline() {
		return this.deadline;
	}

    public int getCowsInCorral ()
    {
        return cowsInCorral;
    }

}
